use Win32::ODBC;
use recurs;

#print join '=', pathcat (@ARGV); exit;
#print join "\n", glob $_ for @ARGV; exit;
#pathname $_ for @ARGV; exit;

print "DBSPY V 1.0 - (w) 11/00 by H. Piske\n";
if (scalar @ARGV < 1)
{
	print "Usage: PERL $0 [/lines] ODBCname [Table]", '
retrieves table names from the ODBC source or dumps one of its tables.
/lines is max. lines to return. Instead of a data source name, you can
also give a file name, having the DSN on the first line and a full
fledged SQL query on the following lines.

You can even dump an excel file. Cool, eh? Only works with the a.m.
file. Put the name of the excel file in line #1 and use [] as the
table name in your select statement.
';
	exit;
}

$limit = 40;
if (@ARGV && $ARGV[0] =~ m!^[-/]\d*$!)
{
	$_ = shift;
	s/.//;
	$limit = $_;
}
$XLDrv = "";
if (@ARGV == 1 && -f $ARGV[0])
{
	$_ = <>;
	chomp;
	$db = m![\\/]! ? "" : new Win32::ODBC ($_);
	unless ($db)
	{
		die "cannot access $_\n" unless /\.xls$/ && -f;
		$_ = substr (`cd`, 0, 2) . $_ unless /:/;
		($path, $dsn) = &pathname ($_);
		$path =~ m/^(..)(.*)$/;
		$path = &pathcat (`cd $1`, $2) unless $2 =~ m!^[\\/]!;
		print "preparing excel file access for $dsn\n";
		%Drivers = Win32::ODBC::Drivers() or die "can\'t get list of ODBC drivers - aborting\n";
		($XLDrv) = grep /excel/i, keys %Drivers;
		$XLDrv or die "don\'t have an ODBC driver for Excel files - aborting\n";
		Win32::ODBC::ConfigDSN (ODBC_REMOVE_DSN, $XLDrv, "DSN=$dsn");
		Win32::ODBC::ConfigDSN (ODBC_ADD_DSN, $XLDrv,
			("DSN=$dsn", "Description=$dsn", "DBQ=$dsn", "DEFAULTDIR=$path",
			 "FIRSTROWHASNAMES=0", "UID=", "PWD="))
			or die "can't create ODBC DSN for $dsn - aborting\n";
		$db = new Win32::ODBC ($dsn)
			or die "cannot access $dsn\n";
	}
	$_ = join "", grep !/^\s*;/, <>;
	unless ($_)
	{
		#$db->Catalog ("", "", "%", "'SYSTEM TABLE', 'TABLE'");
		$db->Catalog ("", "", "%", "");
		#print join "\n", $db->TableList, "\n";
		#exit $db->Close;
	}
	else
	{
		if (/\[\]/)
		{
			$db->Catalog ("", "", "%", "");
			$db->FetchRow ();
			%Data = $db->DataHash ();
			$Data{'TABLE_NAME'} =~ /([^']+)/;
			$temp = $1;
			s/\[\]/"$temp"/g;
		}
		print "$_\n";
		$db->Sql ($_) && print "'$_' returned ", $db->Error, "\n";
	}
}
else
{
	$db = new Win32::ODBC ($_ = shift)
		or die "cannot access $_\n";

	print "accessing $_\n";
	if (defined ($_ = shift))
	{
		print "retrieving from $_\n";
		$where = scalar @ARGV ? " where " . join (" ", @ARGV) : "";
		$_ = "SELECT * FROM \"$_\"$where";
		print "$_\n";
		$db->Sql ($_);
	}
	else
	{
		$db->Catalog ("", "", "%", "'SYSTEM TABLE', 'TABLE'");
	}
}
print join "; ", $db->FieldNames (), "\n";
$i = 0;
$limit = 1000 unless $limit;
while ($db->FetchRow ())
{
#	%Data = $db->DataHash ();
	print join "; ", $db->Data(), "\n";
	last if ($i += 1) >= $limit;
}

$db->Close ();
Win32::ODBC::ConfigDSN (ODBC_REMOVE_DSN, $XLDrv, "DSN=$dsn") if $XLDrv;
